//----------------------------------------------//
//					MMGHOOK V1.0				//
//			  Based on Aru's ScriptHook			//
// Coders: Aru, TEAM 0x539, Matt Pietrek,		//
//		   Wade Brainerd						//
//----------------------------------------------//

#include <windows.h>
#include <d3d9.h>

#include "CustomFiberThread.h"

#include "../ScriptHook/ScriptHookManager.h"
#include "../ScriptHook/Log.h"
#include "../ScriptHook/LoggerFile.h"

CustomFiberThreadDX _customThreadDX;

void DXHookInitialize(IDirect3DDevice9* m_device, D3DPRESENT_PARAMETERS* pPresentationParameters);
void DXHookRender(IDirect3DDevice9* m_device);
void DXHookReset();

BOOL APIENTRY DllMain( HMODULE hModule, DWORD  fdwReason, LPVOID lpReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH: 
        {
			// Initialize loggers
			Log::AddLogger( LoggerFile::GetInstance() );

			// Initialize the script hook manager and register threads
			ScriptHookManager::Initialize();
			ScriptHookManager::RegisterThread( &_customThreadDX );

			ScriptHookManager::RegisterDirectXHook(&DXHookInitialize, &DXHookRender, &DXHookReset);

            break;
        }
        case DLL_PROCESS_DETACH:
        {
			// Shutdown the script hook manager
			ScriptHookManager::Shutdown();

            break;
        }
    }

    return TRUE;
}